<?php

declare(strict_types=1);

namespace Dedi\SyliusMigrationPlugin\Definition;

class ColumnMappingDefinition
{
    private string $targetColumName;
    private ?string $sourceColumnName;
    private ?string $subQuerySql;
    private $value;
    private ?string $alias;
    private ?string $expr;
    private ?string $transformer;
    private ?array $identifierMapping;

    public function __construct(
        string $targetColumName,
        string $sourceColumnName = null,
        string $subQuerySql = null,
        $value = null,
        string $alias = null,
        string $expr = null,
        string $transformer = null,
        array $identifierMapping = null
    ) {
        $this->targetColumName = $targetColumName;
        $this->sourceColumnName = $sourceColumnName;
        $this->subQuerySql = $subQuerySql;
        $this->value = $value;
        $this->alias = $alias;
        $this->expr = $expr;
        $this->transformer = $transformer;
        $this->identifierMapping = $identifierMapping;
    }

    public function getTargetColumName(): string
    {
        return $this->targetColumName;
    }

    public function getSourceColumnName(): ?string
    {
        return $this->sourceColumnName;
    }

    public function getSubQuerySql(): ?string
    {
        return $this->subQuerySql;
    }

    public function getValue()
    {
        return $this->value;
    }

    public function getAlias(): ?string
    {
        return $this->alias;
    }

    public function getIdentifierMapping(): ?array
    {
        return $this->identifierMapping;
    }

    public function getExpr(): ?string
    {
        return $this->expr;
    }

    public function getTransformer(): ?string
    {
        return $this->transformer;
    }
}
